
{

STARPSA.PAS - lrb - 1/22/2008

Operating system: CP/M or Z-System

Compiler: Turbo Pascal 2.0

This program generates ZPLOT-compatible .VEC files for any "star graph"
which has a prime number of points between 7 and 101, inclusive.

After running this program, use ZPLOT to generate a .PLT file from
the .VEC file.

An Epson-compatible dot matrix printer with graphics capability is
needed to print the .PLT files.

Usage: STARPSA p s

where p is the number of points on the star and s is a "skip" number.
Lines are drawn from a point to another point on the star, skipping s
points each time.

Ref: http://primepuzzle.com/blog/starps.html

}

PROGRAM main;

LABEL
    foo;
TYPE
    PRIMES = set of 7..101;
    Str80 = string[80];
VAR
    x,y: ARRAY [1..101] of REAL;
    a,x1,y1,x2,y2,yf: REAL;
    i,j,n: INTEGER;
    ip,jp: INTEGER;
    step,skip: INTEGER;
    radius: REAL;
    points,skips: string[3];
    code: INTEGER;
    prime: PRIMES;
    work: INTEGER;
    good: BOOLEAN;

{$I GRAF1.PAS}
{$I GRAF2.PAS}
{$I PARAMSTB.INC}

BEGIN

    Writeln('');
    Writeln('STARPSA - 1/22/2008 - lrb');
    prime := [7,11,13,17,19,23,29,31,37,41,43,47,53,59,61,67,71,73,79,83,89,97,101];
    good := True;
    work := length(ParamStr(1));
    work := work*length(ParamStr(2));
    If work <> 0 THEN BEGIN
      points := ParamStr(1);
      Val(points,n,code);
      skips := ParamStr(2);
      Val(skips,skip,code);
      step := skip+1;
      IF NOT (n in prime) THEN good := False;
      IF (skip > (n-3)/2) or (skip < 1) THEN good := False;
    END
    ELSE good := False;
    IF NOT good THEN BEGIN
      Writeln('Usage : STARPSA points skip');
      Writeln('where points is a prime number in 7..101');
      Writeln('and skip is less than or equal to (points-3)/2');
      GOTO foo;
    END;

    grinit ('ST'+points+'S'+skips+'.VEC');
    radius := 0.25;

    FOR i := 1 to n DO BEGIN
      a := 6.28318 * i / n;
      x[i] := cos(a)*radius + radius;
      y[i] := sin(a)*radius + radius;
    END;

    Writeln(CON, 'Plotting ',n,'-point skip-',step-1,' star');

    FOR i := 1 to n DO
    BEGIN
        ip := (step*i - (step - 1)) mod n;
        if ip = 0 then ip := n;
        jp := (ip + step) mod n;
        if jp = 0 then jp := n;
        Writeln('drawing ',ip,' ',jp);
        segmnt( x[ip],y[ip], x[jp],y[jp] );
    END;

    Writeln(CON,'Printing title');
    gstrng(0.425,0.95,'ST'+points+'S'+skips);

    gprint;
    color(0);
    erase;
    color(127);

    Writeln(CON, '');
    Writeln(CON, 'Finished plotting.');
    Writeln(CON,'ST'+points+'S'+skips+'.VEC ready for ZPLOT!');

    grfini;
foo:
END.

